//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1   LimeGreen
#property indicator_width1   2 
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame   = PERIOD_CURRENT; // Time frame to use
extern string          AtrPeriods  = "14";           // Average ranges periods - enter periods separated by ";"
double ar[];
double atrPeriods[];
int    size=0;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   SetIndexBuffer(0,ar);
   IndicatorShortName("Average ranges for ("+AtrPeriods+")");
      TimeFrame = MathMax(TimeFrame,_Period);
      
      //
      //
      //
      //
      //
      
      AtrPeriods = StringTrimLeft(StringTrimRight(AtrPeriods));
      if (StringSubstr(AtrPeriods,StringLen(AtrPeriods),1) != ";")
                       AtrPeriods = StringConcatenate(AtrPeriods,";");

         //
         //
         //
         //
         //                                   
            
         int n,s = 0;
         int i = StringFind(AtrPeriods,";",s);
         while (i > 0)
         {
            string current = StringSubstr(AtrPeriods,s,i-s);
            if (current!=";")
            {
               size = ArraySize(atrPeriods)+1;
                      ArrayResize(atrPeriods ,size);
                        n = StringFind(current,";",0); atrPeriods[size-1]  = StrToInteger(StringSubstr(current,0,n));
            }
            s = i + 1;
            i = StringFind(AtrPeriods,";",s);
         }
   return(0);
}

int deinit() { return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(MathMax(Bars-counted_bars,2*TimeFrame/_Period),Bars-1);

   //
   //
   //
   //
   //
   
      for (int i=limit; i>=0; i--)
      {
         int l,y = iBarShift(NULL,TimeFrame,Time[i]);
         ar[i] = 0;
            for (l=0; l<size; l++)
            {
               int    k,arPeriod = (int)atrPeriods[l];
               double avgRange = 0;
               for (k = 0; k<arPeriod; k++) avgRange += iHigh(NULL,TimeFrame,y+k)-iLow(NULL,TimeFrame,y+k); avgRange /= k;
                  ar[i] += avgRange;
            }
         ar[i] /= (double)l;     
      }   
      return(0);      
}